unit SmartData;

interface

uses Graphics;

type TSmartData = class(TObject)
public
        offset: integer;
        scale: integer;
        procedure repaintDataContinuous(Bitmap: TBitmap);
        procedure repaintData(Bitmap: TBitmap);
        procedure repaintDataPoint(Bitmap: TBitmap);
        procedure checkInData(packet: array of byte; length: integer);
        constructor create(SIbyte1, SIbyte2: byte; indexbyte: integer; datanumber: integer; dsize: integer; SImaxYWert: integer; SIminYWert:integer; SImodus: integer; SIcolor: TColor);
        procedure switchToNextSlot;
        procedure initializeSlots;
        function getMode(): integer;
        
private
        Daten: array[0..499] of integer;
        nextslot: integer;
        byte1, byte2: byte;
        modus: integer;
        maxYWert: integer;
        minYWert: integer;
        count: integer;
        color: TColor;
        datanr: integer;
        size: integer;
        index: integer;
end;

implementation

uses Types;

function TSmartData.getMode(): integer;
begin
        getMode:= modus;
end;

constructor TSmartData.create(SIbyte1, SIbyte2: byte; indexbyte: integer; datanumber:integer;  dsize: integer; SImaxYWert: integer;  SIminYWert: integer; SImodus: integer; SIcolor: TColor);
begin
        byte1 := SIbyte1;
        byte2 := SIbyte2;
        maxYWert := SImaxYWert;
        minYWert := SIminYWert;
        modus := SImodus;
        color := SIcolor;
        datanr := datanumber;
        size := dsize;
        index := indexbyte;
end;

procedure TSmartData.repaintDataContinuous(Bitmap: TBitmap);
var i: integer;

begin
Bitmap.Canvas.pen.Color := color;
Bitmap.Canvas.MoveTo(500, 300 - offset + minYWert * 300 div (MaxYWert - MinYWert) - (daten[(500 + nextslot) mod 500]* 300) div (maxYWert - minYWert));
for i := nextslot to nextslot + 499 do begin
        if (daten[(500 + nextslot - (i - nextslot)) mod 500] <> 0) then
                Bitmap.Canvas.LineTo(500 -( i - nextslot), 300 - offset + minYWert * 300 div (MaxYWert - MinYWert) -(scale * daten[(500 + nextslot - (i - nextslot)) mod 500]* 300) div (maxYWert - minYWert));

end;
end;

procedure TSmartData.repaintData(Bitmap: TBitmap);
var i: integer;

begin
Bitmap.Canvas.pen.Color := color;
Bitmap.Canvas.MoveTo(500, 300 - offset + minYWert * 300 div (MaxYWert - MinYWert) - (daten[(500 + nextslot) mod 500]* 300) div (maxYWert - minYWert));
for i := nextslot to nextslot + 499 do begin
        Bitmap.Canvas.LineTo(500 -( i - nextslot), 300 - offset + minYWert * 300 div (MaxYWert - MinYWert) -(scale * daten[(500 + nextslot - (i - nextslot)) mod 500]* 300) div (maxYWert - minYWert));
end;
end;

procedure TSmartData.repaintDataPoint(Bitmap: TBitmap);
var i: integer;

begin
Bitmap.Canvas.pen.Color := color;
Bitmap.Canvas.Brush.Color := color;
for i := nextslot to nextslot + 499 do begin
        Bitmap.Canvas.Ellipse(500 -( i - nextslot) - 1, 300 - offset + minYWert * 300 div (MaxYWert - MinYWert) -(scale * daten[(500 + nextslot - (i - nextslot)) mod 500]* 300) div (maxYWert - minYWert) - 1, 500 -( i - nextslot) + 1, 300 - offset + minYWert * 300 div (MaxYWert - MinYWert) -(daten[(500 + nextslot - (i - nextslot)) mod 500]* 300) div (maxYWert - minYWert) + 1 );
end;

end;

procedure TSmartData.switchToNextSlot;
begin
        daten[nextslot] := count;
        count := 0;
        nextslot := (nextslot + 1) mod 500;
        daten[nextslot] := 0;
end;

procedure TSmartData.initializeSlots;
var i:integer;
begin
        for i := 0 to sizeof(Daten) div sizeof(Integer) -1 do Daten[i] := 0;
        nextslot := 0;
        count := 0;
end;

procedure TSmartData.checkInData(packet: array of byte; length: integer);
var naechsterTyp: integer;
    byteTyp: byte;
    intTyp: integer;
    tmp: array [1..2] of byte;
    dlen: byte;

begin
naechsterTyp := 54;

if (size=0) or (size=1) then dlen := 1;
if (size=2) or (size=3) then dlen := 2;

while (naechsterTyp < length - 2) do begin
        if ((packet[naechsterTyp] = byte1) and (packet[naechsterTyp + 1] = byte2) and ((index = -1) or (packet[naechsterTyp + packet[naechsterTyp + 2] + 2] = index)) ) then begin
                if (modus = 0) then count := count + 1 else
                if ((modus = 1) and (packet[naechsterTyp + 2] >= (datanr + dlen - 1))) then
                        case size of
                             0: begin
                                        byteTyp := packet[naechsterTyp + 2 + datanr];
                                        count := ShortInt(byteTyp);
                                end;
                             2: begin
                                        tmp[1] := packet[naechsterTyp + 2 + datanr + 1];
                                        tmp[2] := packet[naechsterTyp + 2 + datanr];
                                        move(tmp[1], intTyp, 2);
                                        count := SmallInt(intTyp);
                                end;
                             3: begin
                                        tmp[1] := packet[naechsterTyp + 2 + datanr + 1];
                                        tmp[2] := packet[naechsterTyp + 2 + datanr];
                                        move(tmp[1], intTyp, 2);
                                        count := Word(intTyp);
                                end;
                        else    begin
                                        byteTyp  := packet[naechsterTyp + 2 + datanr];
                                        count := Byte(byteTyp);
                                end;
                        end else count := 0;


        end;
        naechsterTyp:= naechsterTyp + 2 + 1 + packet[naechsterTyp + 2];
end;
end;

end.
