unit SmartHelo;

interface
uses Sock;

procedure sendHelo(SendSocket: TSock; var sequence: byte; reciever: array of byte);
procedure SendModID(SendSocket: TSock; ID: array of byte);
procedure CRC16(data: array of byte; length: integer; var phb: byte; var plb:byte);
procedure compute_crc_and_append(var d: array of byte; size: integer);

implementation
uses WinSock, SysUtils, dialogs;

procedure sendHelo(SendSocket: TSock; var sequence: byte; reciever: array of byte);
var
hostname: array [0..255] of char;
HostInfo: PHostEnt;
packet: array[0..69] of byte;
i: integer;


begin
//Version
packet[0] := 2;
//Location
for i:= 1 to 44 do packet[i] := 0;
//ID
packet[45]:=1;
packet[46]:=1;
packet[47]:=1;
packet[48]:=1;
gethostname(@hostname, sizeof(hostname));
HostInfo := gethostbyname(@hostname);
Move(HostInfo^.h_addr_list^[0], packet[49], 4);
//Sequencenumber
packet[53] := sequence;
//HELO
packet[54]:=165;
packet[55]:=14;
packet[56]:=0;
packet[57]:=115;
packet[58]:=216;
packet[59]:=8;

//Helo destination
Move( reciever, packet[60], 8);
//CRC
compute_CRC_and_append(packet, 68);

SendSocket.SendDatagram(@packet, sizeof(packet), '255.255.255.255');

sequence := (sequence + 1) mod 256;
end;


procedure SendModID(SendSocket: TSock; ID: array of byte);
var
hostname: array [0..255] of char;
packet: array[0..69] of byte;
i: integer;
HostInfo: PHostEnt;

begin
  //Version
  packet[0] := 2;
  //Location
  for i:= 1 to 44 do packet[i] := 0;
  //ID
  packet[45]:=1;
  packet[46]:=1;
  packet[47]:=1;
  packet[48]:=1;
  gethostname(@hostname, sizeof(hostname));
  HostInfo := gethostbyname(@hostname);
  Move(HostInfo^.h_addr_list^[0], packet[49], 4);
  //Sequencenumber
  packet[53] := 0;
  //HELO
  packet[54]:=165;
  packet[55]:=14;
  packet[56]:=0;
  packet[57]:=109;
  packet[58]:=192;
  packet[59]:=8;

  //Helo destination
  Move(ID, packet[60], 8);
  //CRC
  compute_CRC_and_append(packet,68);
  SendSocket.SendDatagram(@packet, sizeof(packet), '255.255.255.255');

end;

{
/*****************************************************************************/
/* Procedure CRC16. Calculates CRC16 using                                   */
/* the CCITT 16bit algorithm (X^16 + X^12 + X^5 + 1).			     */
/*****************************************************************************/}
procedure CRC16(data: array of byte; length: integer; var phb: byte; var plb:byte);
var
hb,lb,i,tmp: byte;

begin
	//calcs a crc on LL_header, ACL_data, LL_tail

	lb:= phb;
	hb:= plb;

        for i:= 0 to length - 1 do begin
		tmp := lb;
		lb := hb;
		hb := tmp;
		lb := lb xor data[i];
		lb := lb xor (lb shr 4);
		hb := hb xor (lb shl 4);
		hb := hb xor (lb shr 3);
		lb := lb xor ((lb shl 4) shl 1);
	end;

	phb := hb;
	plb := lb;
end;

{/*****************************************************************************/
/* Appends CRC16 to d, where size is length of d and appends it              */
/*****************************************************************************/}
procedure compute_crc_and_append(var d: array of byte; size: integer);
var
hb, lb: byte;

begin

   hb := 0;
   lb := 0;

   CRC16(d, size, hb, lb);

   d[size] := hb;
   d[size + 1] := lb;
end;

end.
 